import java.util.*;
import javax.ejb.*;
import java.sql.*;
import javax.sql.*;
import javax.naming.*;
import javax.rmi.PortableRemoteObject;

public class PocketMoneySessionBean implements SessionBean {
	private String owner;
	private PocketMoney pocketMoney = null;

	private SessionContext context;
	private String ejbPocketMoney = "java:comp/env/ejb/PocketMoney";

	public void ejbCreate() throws CreateException {
	}

	public void ejbCreate(String owner) throws CreateException {
		this.owner = owner;
	}

	public void ejbRemove() {}
	public void ejbActivate() {}
	public void ejbPassivate() {}

	public void setSessionContext(SessionContext context) {
		this.context = context;
	}

	public PocketMoneySessionBean() {}

	public void createAccount() throws CreateException {
		pocketMoney = getPocketMoneyHome().create(owner, 0);
	}

	public void removeAccount() throws RemoveException {
		Iterator it = pocketMoney.getLines().iterator();
		while (it.hasNext()) {
			((PocketMoneyLine)it.next()).remove();
		}
		pocketMoney.remove();
	}

	public PocketMoneyVO get() {
		return pocketMoney.getVO();
	}

	public Collection getLines() {
		Vector result = new Vector();
		Iterator it = pocketMoney.getLines().iterator();;
		while (it.hasNext()) {
			result.add(((PocketMoneyLine)it.next()).getVO());
		}
		return result;
	}

	public void deposit(int amount, String reason) {
		pocketMoney.deposit(amount, reason);
	}

	public void payment(int amount, String reason) {
		pocketMoney.payment(amount, reason);
	}

	protected PocketMoneyHome getPocketMoneyHome() {
		try {
			InitialContext ic = new InitialContext();
			Object objref = ic.lookup(ejbPocketMoney);
			PocketMoneyHome home = (PocketMoneyHome)PortableRemoteObject.narrow(objref, PocketMoneyHome.class);
			ic.close();
			return home;
		} catch (NamingException ex) {
			throw new RuntimeException(ex.getMessage());
		}
	}
}
