import java.sql.*;
import javax.sql.*;
import java.util.*;
import javax.ejb.*;
import javax.naming.*;
import javax.rmi.PortableRemoteObject;

abstract public class PocketMoneyBean implements EntityBean {
	private String ejbPocketMoneyLine = "java:comp/env/ejb/PocketMoneyLine";
	private EntityContext context;

	abstract public String getOwner();
	abstract public void setOwner(String owner);
	abstract public int getRemaining();
	abstract public void setRemaining(int remaining);
	abstract public Collection getLines();
	abstract public void setLines(Collection lines);

	public PocketMoneyVO getVO() {
		return new PocketMoneyVO(getOwner(), getRemaining());
	}

	public void setEntityContext(EntityContext context) {
		this.context = context;
	}

	public void unsetEntityContext() {
		this.context = null;
	}

	public void ejbActivate() {}
	public void ejbPassivate() {}

	public String ejbCreate(String owner, int remaining) throws CreateException {
		setOwner(owner);
		setRemaining(remaining);
		return null;
	}

	public void ejbPostCreate(String owner, int remaining) {}
	public void ejbRemove() throws RemoveException {}
	public void ejbLoad() {}
	public void ejbStore() {}

	public void deposit(int amount, String reason) {
		try {
			setRemaining(getRemaining() + amount);
			PocketMoneyLine line = getPocketMoneyLineHome().create(getOwner(), new Timestamp(System.currentTimeMillis()), amount, reason);
			getLines().add(line);
		} catch (Exception ex) {
			ex.printStackTrace();
			throw new EJBException(ex);
		}
	}

	public void payment(int amount, String reason) {
		this.deposit(- amount, reason);
	}

	protected PocketMoneyLineHome getPocketMoneyLineHome() {
		try {
			InitialContext ic = new InitialContext();
			Object objref = ic.lookup(ejbPocketMoneyLine);
			PocketMoneyLineHome home = (PocketMoneyLineHome)PortableRemoteObject.narrow(objref, PocketMoneyLineHome.class);
			ic.close();
			return home;
		} catch (NamingException ex) {
			throw new RuntimeException(ex.getMessage());
		}
	}
}
