import java.util.*;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;

public class PocketMoneyClient {

	public static void main(String[] args) {
		try {
			Context initial = new InitialContext();
			Object objref = initial.lookup("java:comp/env/ejb/SimplePocketMoneySession");
			PocketMoneySessionHome home = (PocketMoneySessionHome)PortableRemoteObject.narrow(objref, PocketMoneySessionHome.class);
			PocketMoneySession pm = home.create("Nakajima");
			pm.createAccount();
			printResult(pm, "Nakajima");
			pm.deposit(30000, "monthly");
			Thread.sleep(1000);
			pm.payment(3000, "wine");
			Thread.sleep(1000);
			pm.payment(1000, "wine");
			printResult(pm, "Nakajima");
			pm.removeAccount();
			pm.remove();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		System.exit(0);
	} 

	public static void printResult(PocketMoneySession pm, String owner) throws Exception {
		System.out.println(owner + "'s pocket money is " + pm.get());
		Iterator it = pm.getLines().iterator();
		while (it.hasNext()) {
			PocketMoneyLineVO pmline = (PocketMoneyLineVO)it.next();
			System.out.println("pmline: " + pmline);
		}
	}
}
