import java.util.*;
import javax.ejb.*;
import java.sql.*;
import javax.sql.*;
import javax.naming.*;

public class PocketMoneySessionBean implements SessionBean {
	private SessionContext context;
	private String dbName = "java:comp/env/jdbc/PocketMoneyDB";

	public void ejbCreate() throws CreateException {}
	public void ejbRemove() {}
	public void ejbActivate() {}
	public void ejbPassivate() {}

	public void setSessionContext(SessionContext context) {
		this.context = context;
	}

	public PocketMoneySessionBean() {}

	public void createAccount(String owner) {
		Connection co = null;
		PreparedStatement st = null;
		try {
			co = this.getConnection();
			st = co.prepareStatement("insert into pm values(?, ?)");
			st.setString(1, owner);
			st.setInt(2, 0);
			int uc = st.executeUpdate();
		} catch (Exception ex) {
			ex.printStackTrace();
			throw new EJBException(ex);
		} finally {
			try {st.close();} catch (Exception ex) {}
			try {co.close();} catch (Exception ex) {}
		}
	}

	public void removeAccount(String owner) {
		Connection co = null;
		PreparedStatement stPm = null;
		PreparedStatement stPmLine = null;
		try {
			co = this.getConnection();
			stPm = co.prepareStatement("delete from pm where owner = ?");
			stPm.setString(1, owner);
			int uc = stPm.executeUpdate();
			stPmLine = co.prepareStatement("delete from pmline where owner = ?");
			stPmLine.setString(1, owner);
			int ic = stPmLine.executeUpdate();
		} catch (Exception ex) {
			ex.printStackTrace();
			throw new EJBException(ex);
		} finally {
			try {stPmLine.close();} catch (Exception ex) {}
			try {stPm.close();} catch (Exception ex) {}
			try {co.close();} catch (Exception ex) {}
		}
	}

	public PocketMoney get(String owner) {
		Connection co = null;
		PreparedStatement st = null;
		ResultSet rs = null;
		PocketMoney result = null;
		try {
			co = this.getConnection();
			st = co.prepareStatement("select * from pm where owner = ?");
			st.setString(1, owner);
			rs = st.executeQuery();
			while (rs.next()) {
				result = new PocketMoney(rs.getString(1), rs.getInt(2));
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw new EJBException(ex);
		} finally {
			try {rs.close();} catch (Exception ex) {}
			try {st.close();} catch (Exception ex) {}
			try {co.close();} catch (Exception ex) {}
		}
		return result;
	} 

	public Collection getLines(String owner) {
		Connection co = null;
		PreparedStatement st = null;
		ResultSet rs = null;
		Vector result = new Vector();
		try {
			co = this.getConnection();
			st = co.prepareStatement("select * from pmline where owner = ?");
			st.setString(1, owner);
			rs = st.executeQuery();
			while (rs.next()) {
				result.add(new PocketMoneyLine(rs.getString(1), rs.getTimestamp(2), rs.getInt(3), rs.getString(4)));
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw new EJBException(ex);
		} finally {
			try {rs.close();} catch (Exception ex) {}
			try {st.close();} catch (Exception ex) {}
			try {co.close();} catch (Exception ex) {}
		}
		return result;
	}

	public void deposit(String owner, int amount, String reason) {
		Connection co = null;
		PreparedStatement stPm = null;
		PreparedStatement stPmLine = null;
		try {
			co = this.getConnection();
			stPm = co.prepareStatement("update pm set remaining = remaining + ? where owner = ?");
			stPm.setInt(1, amount);
			stPm.setString(2, owner);
			int uc = stPm.executeUpdate();
			stPmLine = co.prepareStatement("insert into pmline values(?, ?, ?, ?)");
			stPmLine.setString(1, owner);
			stPmLine.setTimestamp(2, new Timestamp(System.currentTimeMillis()));
			stPmLine.setInt(3, amount);
			stPmLine.setString(4, reason);
			int ic = stPmLine.executeUpdate();
		} catch (Exception ex) {
			ex.printStackTrace();
			throw new EJBException(ex);
		} finally {
			try {stPmLine.close();} catch (Exception ex) {}
			try {stPm.close();} catch (Exception ex) {}
			try {co.close();} catch (Exception ex) {}
		}
	}

	public void payment(String owner, int amount, String reason) {
		this.deposit(owner, - amount, reason);
	}

	private Connection getConnection() throws NamingException, SQLException {
		InitialContext ic = new InitialContext();
		DataSource ds = (DataSource)ic.lookup(dbName);
		Connection co = ds.getConnection();
		ic.close();
		return co;
	}
}
