import java.util.*;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;

public class PocketMoneyClient {

	public static void main(String[] args) {
		try {
			Context initial = new InitialContext();
			Object objref = initial.lookup("java:comp/env/ejb/SimplePocketMoneySession");
			PocketMoneySessionHome home = (PocketMoneySessionHome)PortableRemoteObject.narrow(objref, PocketMoneySessionHome.class);
			PocketMoneySession pm = home.create();
			pm.createAccount("Nakajima");
			printResult(pm, "Nakajima");
			pm.deposit("Nakajima", 30000, "monthly");
			Thread.sleep(1000);
			pm.payment("Nakajima", 3000, "wine");
			Thread.sleep(1000);
			pm.payment("Nakajima", 1000, "wine");
			printResult(pm, "Nakajima");
			pm.removeAccount("Nakajima");
			pm.remove();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		System.exit(0);
	} 

	public static void printResult(PocketMoneySession pm, String owner) throws Exception {
		System.out.println(owner + "'s pocket money is " + pm.get(owner));
		Iterator it = pm.getLines(owner).iterator();
		while (it.hasNext()) {
			PocketMoneyLine pmline = (PocketMoneyLine)it.next();
			System.out.println("pmline: " + pmline);
		}
	}
}
